update sse2 regular quantizer
[libvpx.git] / configure
blob5a502ae33bc116c41075925f7004292ead7c969a
1 #!/bin/bash
2 ##
3 ## configure
4 ##
5 ## This script is the front-end to the build system. It provides a similar
6 ## interface to standard configure scripts with some extra bits for dealing
7 ## with toolchains that differ from the standard POSIX interface and
8 ## for extracting subsets of the source tree. In theory, reusable parts
9 ## of this script were intended to live in build/make/configure.sh,
10 ## but in practice, the line is pretty blurry.
12 ## This build system is based in part on the FFmpeg configure script.
15 #source_path="`dirname \"$0\"`"
16 source_path=${0%/*}
17 . "${source_path}/build/make/configure.sh"
19 show_help(){
20 show_help_pre
21 cat << EOF
22 Advanced options:
23 ${toggle_libs} don't build libraries
24 ${toggle_examples} don't build examples
25 --libc=PATH path to alternate libc
26 --as={yasm|nasm|auto} use specified assembler [auto, yasm preferred]
27 ${toggle_fast_unaligned} don't use unaligned accesses, even when
28 supported by hardware [auto]
29 ${toggle_codec_srcs} in/exclude codec library source code
30 ${toggle_debug_libs} in/exclude debug version of libraries
31 ${toggle_md5} support for output of checksum data
32 ${toggle_static_msvcrt} use static MSVCRT (VS builds only)
33 ${toggle_vp8} VP8 codec support
34 ${toggle_psnr} output of PSNR data, if supported (encoders)
35 ${toggle_mem_tracker} track memory usage
36 ${toggle_postproc} postprocessing
37 ${toggle_multithread} multithreaded encoding and decoding.
38 ${toggle_spatial_resampling} spatial sampling (scaling) support
39 ${toggle_realtime_only} enable this option while building for real-time encoding
40 ${toggle_runtime_cpu_detect} runtime cpu detection
41 ${toggle_shared} shared library support
42 ${toggle_small} favor smaller size over speed
43 ${toggle_arm_asm_detok} assembly version of the detokenizer (ARM platforms only)
44 ${toggle_postproc_visualizer} macro block / block level visualizers
46 Codecs:
47 Codecs can be selectively enabled or disabled individually, or by family:
48 --disable-<codec>
49 is equivalent to:
50 --disable-<codec>-encoder
51 --disable-<codec>-decoder
53 Codecs available in this distribution:
54 EOF
55 #restore editor state '
57 local family;
58 local last_family;
59 local c;
60 local str;
61 for c in ${CODECS}; do
62 family=${c%_*}
63 if [ "${family}" != "${last_family}" ]; then
64 [ -z "${str}" ] || echo "${str}"
65 str="$(printf ' %10s:' ${family})"
67 str="${str} $(printf '%10s' ${c#*_})"
68 last_family=${family}
69 done
70 echo "${str}"
71 show_help_post
75 ## BEGIN APPLICATION SPECIFIC CONFIGURATION
78 # all_platforms is a list of all supported target platforms. Maintain
79 # alphabetically by architecture, generic-gnu last.
80 all_platforms="${all_platforms} armv5te-linux-rvct"
81 all_platforms="${all_platforms} armv5te-linux-gcc"
82 all_platforms="${all_platforms} armv5te-symbian-gcc"
83 all_platforms="${all_platforms} armv5te-wince-vs8"
84 all_platforms="${all_platforms} armv6-darwin-gcc"
85 all_platforms="${all_platforms} armv6-linux-rvct"
86 all_platforms="${all_platforms} armv6-linux-gcc"
87 all_platforms="${all_platforms} armv6-symbian-gcc"
88 all_platforms="${all_platforms} armv6-wince-vs8"
89 all_platforms="${all_platforms} iwmmxt-linux-rvct"
90 all_platforms="${all_platforms} iwmmxt-linux-gcc"
91 all_platforms="${all_platforms} iwmmxt-wince-vs8"
92 all_platforms="${all_platforms} iwmmxt2-linux-rvct"
93 all_platforms="${all_platforms} iwmmxt2-linux-gcc"
94 all_platforms="${all_platforms} iwmmxt2-wince-vs8"
95 all_platforms="${all_platforms} armv7-darwin-gcc" #neon Cortex-A8
96 all_platforms="${all_platforms} armv7-linux-rvct" #neon Cortex-A8
97 all_platforms="${all_platforms} armv7-linux-gcc" #neon Cortex-A8
98 all_platforms="${all_platforms} mips32-linux-gcc"
99 all_platforms="${all_platforms} ppc32-darwin8-gcc"
100 all_platforms="${all_platforms} ppc32-darwin9-gcc"
101 all_platforms="${all_platforms} ppc32-linux-gcc"
102 all_platforms="${all_platforms} ppc64-darwin8-gcc"
103 all_platforms="${all_platforms} ppc64-darwin9-gcc"
104 all_platforms="${all_platforms} ppc64-linux-gcc"
105 all_platforms="${all_platforms} sparc-solaris-gcc"
106 all_platforms="${all_platforms} x86-darwin8-gcc"
107 all_platforms="${all_platforms} x86-darwin8-icc"
108 all_platforms="${all_platforms} x86-darwin9-gcc"
109 all_platforms="${all_platforms} x86-darwin9-icc"
110 all_platforms="${all_platforms} x86-linux-gcc"
111 all_platforms="${all_platforms} x86-linux-icc"
112 all_platforms="${all_platforms} x86-solaris-gcc"
113 all_platforms="${all_platforms} x86-win32-gcc"
114 all_platforms="${all_platforms} x86-win32-vs7"
115 all_platforms="${all_platforms} x86-win32-vs8"
116 all_platforms="${all_platforms} x86-win32-vs9"
117 all_platforms="${all_platforms} x86_64-darwin9-gcc"
118 all_platforms="${all_platforms} x86_64-darwin10-gcc"
119 all_platforms="${all_platforms} x86_64-linux-gcc"
120 all_platforms="${all_platforms} x86_64-linux-icc"
121 all_platforms="${all_platforms} x86_64-solaris-gcc"
122 all_platforms="${all_platforms} x86_64-win64-vs8"
123 all_platforms="${all_platforms} x86_64-win64-vs9"
124 all_platforms="${all_platforms} universal-darwin8-gcc"
125 all_platforms="${all_platforms} universal-darwin9-gcc"
126 all_platforms="${all_platforms} generic-gnu"
128 # all_targets is a list of all targets that can be configured
129 # note that these should be in dependency order for now.
130 all_targets="libs examples docs"
132 # all targets available are enabled, by default.
133 for t in ${all_targets}; do
134 [ -f ${source_path}/${t}.mk ] && enable ${t}
135 done
137 # check installed doxygen version
138 doxy_version=$(doxygen --version 2>/dev/null)
139 doxy_major=${doxy_version%%.*}
140 if [ ${doxy_major:-0} -ge 1 ]; then
141 doxy_version=${doxy_version#*.}
142 doxy_minor=${doxy_version%%.*}
143 doxy_patch=${doxy_version##*.}
145 [ $doxy_major -gt 1 ] && enable doxygen
146 [ $doxy_minor -gt 5 ] && enable doxygen
147 [ $doxy_minor -eq 5 ] && [ $doxy_patch -ge 3 ] && enable doxygen
150 # install everything except the sources, by default. sources will have
151 # to be enabled when doing dist builds, since that's no longer a common
152 # case.
153 enabled doxygen && php -v >/dev/null 2>&1 && enable install_docs
154 enable install_bins
155 enable install_libs
157 enable optimizations
158 enable fast_unaligned #allow unaligned accesses, if supported by hw
159 enable md5
160 enable spatial_resampling
161 enable multithread
163 [ -d ${source_path}/../include ] && enable alt_tree_layout
164 for d in vp8; do
165 [ -d ${source_path}/${d} ] && disable alt_tree_layout;
166 done
168 if ! enabled alt_tree_layout; then
169 # development environment
170 [ -d ${source_path}/vp8 ] && CODECS="${CODECS} vp8_encoder vp8_decoder"
171 else
172 # customer environment
173 [ -f ${source_path}/../include/vpx/vp8cx.h ] && CODECS="${CODECS} vp8_encoder"
174 [ -f ${source_path}/../include/vpx/vp8dx.h ] && CODECS="${CODECS} vp8_decoder"
176 [ -f ${source_path}/../lib/*/*mt.lib ] && soft_enable static_msvcrt
179 CODECS="$(echo ${CODECS} | tr ' ' '\n')"
180 CODEC_FAMILIES="$(for c in ${CODECS}; do echo ${c%_*}; done | sort | uniq)"
182 ARCH_LIST="
184 mips
186 x86_64
187 ppc32
188 ppc64
190 ARCH_EXT_LIST="
191 armv5te
192 armv6
193 armv7
194 iwmmxt
195 iwmmxt2
197 mips32
201 sse2
202 sse3
203 ssse3
204 sse4_1
206 altivec
208 HAVE_LIST="
209 ${ARCH_EXT_LIST}
210 vpx_ports
211 stdint_h
212 alt_tree_layout
213 pthread_h
214 sys_mman_h
216 CONFIG_LIST="
217 external_build
218 install_docs
219 install_bins
220 install_libs
221 install_srcs
222 debug
223 gprof
224 gcov
225 rvct
227 msvs
229 big_endian
231 codec_srcs
232 debug_libs
233 fast_unaligned
234 mem_manager
235 mem_tracker
236 mem_checks
239 dequant_tokens
240 dc_recon
241 runtime_cpu_detect
242 postproc
243 multithread
244 psnr
245 ${CODECS}
246 ${CODEC_FAMILIES}
247 encoders
248 decoders
249 static_msvcrt
250 spatial_resampling
251 realtime_only
252 shared
253 small
254 arm_asm_detok
255 postproc_visualizer
257 CMDLINE_SELECT="
258 extra_warnings
259 werror
260 install_docs
261 install_bins
262 install_libs
263 install_srcs
264 debug
265 gprof
266 gcov
268 optimizations
269 ccache
270 runtime_cpu_detect
272 libs
273 examples
274 libc
276 fast_unaligned
277 codec_srcs
278 debug_libs
281 dequant_tokens
282 dc_recon
283 postproc
284 multithread
285 psnr
286 ${CODECS}
287 ${CODEC_FAMILIES}
288 static_msvcrt
289 mem_tracker
290 spatial_resampling
291 realtime_only
292 shared
293 small
294 arm_asm_detok
295 postproc_visualizer
298 process_cmdline() {
299 for opt do
300 optval="${opt#*=}"
301 case "$opt" in
302 --disable-codecs) for c in ${CODECS}; do disable $c; done ;;
303 *) process_common_cmdline $opt
305 esac
306 done
309 post_process_cmdline() {
310 local c
312 # If the codec family is disabled, disable all components of that family.
313 # If the codec family is enabled, enable all components of that family.
314 log_echo "Configuring selected codecs"
315 for c in ${CODECS}; do
316 disabled ${c%%_*} && disable ${c}
317 enabled ${c%%_*} && enable ${c}
318 done
320 # Enable all detected codecs, if they haven't been disabled
321 for c in ${CODECS}; do soft_enable $c; done
323 # Enable the codec family if any component of that family is enabled
324 for c in ${CODECS}; do
325 enabled $c && enable ${c%_*}
326 done
328 # Set the {en,de}coders variable if any algorithm in that class is enabled
329 for c in ${CODECS}; do
330 enabled ${c} && enable ${c##*_}s
331 done
335 process_targets() {
336 enabled child || write_common_config_banner
337 enabled universal || write_common_target_config_h ${BUILD_PFX}vpx_config.h
339 # TODO: add host tools target (obj_int_extract, etc)
341 # For fat binaries, call configure recursively to configure for each
342 # binary architecture to be included.
343 if enabled universal; then
344 # Call configure (ourselves) for each subarchitecture
345 for arch in $fat_bin_archs; do
346 BUILD_PFX=${arch}/ toolchain=${arch} $self --child $cmdline_args || exit $?
347 done
350 # The write_common_config (config.mk) logic is deferred until after the
351 # recursive calls to configure complete, becuase we want our universal
352 # targets to be executed last.
353 write_common_config_targets
354 enabled universal && echo "FAT_ARCHS=${fat_bin_archs}" >> config.mk
356 # Calculate the default distribution name, based on the enabled features
357 local cf
358 local DIST_DIR=vpx
359 for cf in $CODEC_FAMILIES; do
360 if enabled ${cf}_encoder && enabled ${cf}_decoder; then
361 DIST_DIR="${DIST_DIR}-${cf}"
362 elif enabled ${cf}_encoder; then
363 DIST_DIR="${DIST_DIR}-${cf}cx"
364 elif enabled ${cf}_decoder; then
365 DIST_DIR="${DIST_DIR}-${cf}dx"
367 done
368 enabled debug_libs && DIST_DIR="${DIST_DIR}-debug"
369 enabled codec_srcs && DIST_DIR="${DIST_DIR}-src"
370 ! enabled postproc && DIST_DIR="${DIST_DIR}-nopost"
371 ! enabled multithread && DIST_DIR="${DIST_DIR}-nomt"
372 ! enabled install_docs && DIST_DIR="${DIST_DIR}-nodocs"
373 DIST_DIR="${DIST_DIR}-${tgt_isa}-${tgt_os}"
374 case "${tgt_os}" in
375 win*) enabled static_msvcrt && DIST_DIR="${DIST_DIR}mt" || DIST_DIR="${DIST_DIR}md"
376 DIST_DIR="${DIST_DIR}-${tgt_cc}"
378 esac
379 if [ -f "${source_path}/build/make/version.sh" ]; then
380 local ver=`"$source_path/build/make/version.sh" --bare $source_path`
381 DIST_DIR="${DIST_DIR}-${ver}"
382 ver=${ver%%-*}
383 VERSION_PATCH=${ver##*.}
384 ver=${ver%.*}
385 VERSION_MINOR=${ver##*.}
386 ver=${ver#v}
387 VERSION_MAJOR=${ver%.*}
389 enabled child || cat <<EOF >> config.mk
390 ifeq (\$(MAKECMDGOALS),dist)
391 DIST_DIR?=${DIST_DIR}
392 else
393 DIST_DIR?=\$(DESTDIR)${prefix}
394 endif
395 LIBSUBDIR=${libdir##${prefix}/}
397 VERSION_MAJOR=${VERSION_MAJOR}
398 VERSION_MINOR=${VERSION_MINOR}
399 VERSION_PATCH=${VERSION_PATCH}
401 CONFIGURE_ARGS=${CONFIGURE_ARGS}
403 enabled child || echo "CONFIGURE_ARGS?=${CONFIGURE_ARGS}" >> config.mk
406 # Write makefiles for all enabled targets
408 for tgt in libs examples docs solution; do
409 local tgt_fn="$tgt-$toolchain.mk"
411 if enabled $tgt; then
412 echo "Creating makefiles for ${toolchain} ${tgt}"
413 write_common_target_config_mk $tgt_fn ${BUILD_PFX}vpx_config.h
414 #write_${tgt}_config
416 done
420 process_detect() {
421 if enabled shared; then
422 # Can only build shared libs on a subset of platforms. Doing this check
423 # here rather than at option parse time because the target auto-detect
424 # magic happens after the command line has been parsed.
425 enabled linux || die "--enable-shared only supported on ELF for now"
427 if [ -z "$CC" ]; then
428 echo "Bypassing toolchain for environment detection."
429 enable external_build
430 check_header() {
431 log fake_check_header "$@"
432 header=$1
433 shift
434 var=`echo $header | sed 's/[^A-Za-z0-9_]/_/g'`
435 disable $var
436 case $header in
437 stdio.h)
438 true;
441 local result=false
442 for d in "$@"; do
443 [ -f "${d##-I}/$header" ] && result=true && break
444 done
445 ${result:-true}
446 esac && enable $var
448 check_ld() {
449 true
452 check_header stdio.h || die "Unable to invoke compiler: ${CC} ${CFLAGS}"
453 check_ld <<EOF || die "Toolchain is unable to link executables"
454 int main(void) {return 0;}
456 # check system headers
457 check_header stdint.h
458 check_header pthread.h
459 check_header sys/mman.h
461 check_header vpx/vpx_integer.h -I${source_path} && enable vpx_ports
464 process_toolchain() {
465 process_common_toolchain
467 # Handle universal binaries for this architecture
468 case $toolchain in
469 universal-darwin*)
470 local darwin_ver=${tgt_os##darwin}
471 fat_bin_archs="$fat_bin_archs ppc32-${tgt_os}-gcc"
473 # Intel
474 fat_bin_archs="$fat_bin_archs x86-${tgt_os}-${tgt_cc}"
475 if [ $darwin_ver -gt 8 ]; then
476 fat_bin_archs="$fat_bin_archs x86_64-${tgt_os}-${tgt_cc}"
479 esac
482 # Enable some useful compiler flags
483 if enabled gcc; then
484 enabled werror && check_add_cflags -Werror
485 check_add_cflags -Wall
486 check_add_cflags -Wdeclaration-after-statement
487 check_add_cflags -Wdisabled-optimization
488 check_add_cflags -Wpointer-arith
489 check_add_cflags -Wtype-limits
490 check_add_cflags -Wcast-qual
491 enabled extra_warnings || check_add_cflags -Wno-unused
494 if enabled icc; then
495 enabled werror && check_add_cflags -Werror
496 check_add_cflags -Wall
497 check_add_cflags -Wpointer-arith
499 # ICC has a number of floating point optimizations that we disable
500 # in favor of deterministic output WRT to other compilers
501 add_cflags -fp-model precise
504 # Enable extra, harmless warnings. These might provide additional insight
505 # to what the compiler is doing and why, but in general, but they shouldn't
506 # be treated as fatal, even if we're treating warnings as errors.
507 GCC_EXTRA_WARNINGS="
508 -Wdisabled-optimization
509 -Winline
511 enabled gcc && EXTRA_WARNINGS="${GCC_EXTRA_WARNINGS}"
512 RVCT_EXTRA_WARNINGS="
513 --remarks
515 enabled rvct && EXTRA_WARNINGS="${RVCT_EXTRA_WARNINGS}"
516 if enabled extra_warnings; then
517 for w in ${EXTRA_WARNINGS}; do
518 check_add_cflags ${w}
519 enabled gcc && enabled werror && check_add_cflags -Wno-error=${w}
520 done
523 # ccache only really works on gcc toolchains
524 enabled gcc || soft_disable ccache
525 if enabled mips; then
526 enable dequant_tokens
527 enable dc_recon
530 # Enable the postbuild target if building for visual studio.
531 case "$tgt_cc" in
532 vs*) enable msvs
533 enable solution
534 vs_version=${tgt_cc##vs}
535 all_targets="${all_targets} solution"
537 esac
539 # Other toolchain specific defaults
540 case $toolchain in x86*|ppc*|universal*) soft_enable postproc;; esac
542 if enabled postproc_visualizer; then
543 enabled postproc || die "postproc_visualizer requires postproc to be enabled"
549 ## END APPLICATION SPECIFIC CONFIGURATION
551 CONFIGURE_ARGS="$@"
552 process "$@"
553 cat <<EOF > ${BUILD_PFX}vpx_config.c
554 static const char* const cfg = "$CONFIGURE_ARGS";
555 const char *vpx_codec_build_config(void) {return cfg;}